; DISK VERIFY   by Michael LaChapelle (MJL!)
; last update: 6/26/89

  TEXT
  INCLUDE TOS\XBIOS.S
  INCLUDE TOS\GEMDOS.S
  INCLUDE TOS\EZMAC.S

  GETREZ                            ;SAVE RESOLUTION
  MOVE D0,REZ
  CMP #2,D0                         ;MONOCHROME?
  BEQ RESTART
  SETSCREEN #1,-1,-1                ;SET MEDIUM RES
RESTART:
  CLS
  CURSOR ON
  CURSOR SOLID
  WRAPON
  PRINTCR '                                   DISK VERIFY'
  PRINTCR '                                     [v 1.7]'
  DOWN
  PRINTCR '                                     May 1989'
  PRINTCR '                               by ML & ML Software'
  PRINTCR '                                 written by MJL!'
WHICHDRIVE:
  PRINT_AT #0,#7,'                       Test disk in drive A, B, or X-it? '
  CAPSIN
  MOVE.B D0,DRIVECH
  CMP.B #'A',D0
  BEQ DRIVE0
  CMP.B #'B',D0
  BEQ DRIVE1
  CMP.B #'X',D0
  BNE WHICHDRIVE
  TERM
DRIVE0:
  MOVE #0,DRIVE
  BRA ALLSET
DRIVE1:
  MOVE #1,DRIVE
ALLSET:
  POSITION #0,#7
  ERASEEOS
  PRINTLINE INSERTDISK
  PRINTCR '(Note :disk data will NOT be modified)'
  PRINTCR '(Note2:write-protect the disk anyway!)'
  DOWN
  PRINT 'Press RETURN when ready: '
GETKEY:
  KEYIN
  CMP.B #13,D0
  BNE GETKEY
  POSITION #0,#7
  ERASEEOS
  PRINT_AT #0,#12,'Commencing disk verification... '
  CURSOR OFF
  FLOPRD #1,#0,#0,#10,DRIVE,BUFFER
  TST D0
  BEQ TEN
  FLOPRD #1,#0,#79,#10,DRIVE,BUFFER
  TST D0
  BEQ TEN
NINE:
  MOVE #9,SECTORS
  PRINT '( 9 sectors per track )'
  BRA INIT
TEN:
  MOVE #10,SECTORS
  PRINT '( 10 sectors per track )'
INIT:
  POSITION #0,#14
  PRINTLINE SECTORLIST
  POSITION #0,#17
  MOVE #0,SIDE
  MOVE #0,TRACK
  MOVE #0,ERROR
CHECKLOOP:
  CHARCOLOR #2
  REVERSEON
  SAVECURSOR
  PRINT 'V'
  RESTORECURSOR
  REVERSEOFF
  CHARCOLOR #3
  FLOPRD SECTORS,SIDE,TRACK,#1,DRIVE,BUFFER
  TST D0
  BEQ A_OK
  CHARCOLOR #1
  PRINT 'E'
  CHARCOLOR #3
  ADDQ #1,ERROR
  BRA NEXT
A_OK:
  PRINT '.'
NEXT:
  MOVE TRACK,D0
  ADDQ #1,D0
  MOVE D0,TRACK
  CMP #80,D0
  BNE CHECKLOOP
  MOVE SIDE,D0
  ADDQ #1,D0
  MOVE D0,SIDE
  CMP #2,D0
  BEQ ALLDONE
  FLOPRD SECTORS,#1,#1,#1,DRIVE,BUFFER
  TST D0
  BEQ RD2
  FLOPRD SECTORS,#1,#79,#1,DRIVE,BUFFER
  TST D0
  BNE ALLDONE
RD2:
  PRINT_AT #0,#22,'Side one verification complete'
  POSITION #0,#18
  MOVE #0,TRACK
  BRA CHECKLOOP
ALLDONE:
  POSITION #0,#12
  CLEARLINE
  CURSOR ON
  PRINT_AT #0,#22,'Disk verification complete, '
  TST ERROR
  BEQ ALLOK
  CONOUT #'$'
  PRINTHEX ERROR
  PRINTCR ' error(s) found'
  BRA EXIT
ALLOK:
  PRINTCR 'no errors found'
EXIT:
  PRINT "'X' to exit, any other key restarts: "
  CAPSIN
  CMP #'X',D0
  BNE RESTART
  SETSCREEN REZ,-1,-1               ;RESTORE RESOLUTION
  TERM

  DATA
INSERTDISK DC.B 'Insert disk in drive '
DRIVECH    DC.B 'A',$0D,$0A,$0A,0
  ALIGN
SECTORLIST DC.B '00000000001111111111222222222233333333334444444444555555555566666666667777777777'
           DC.B '01234567890123456789012345678901234567890123456789012345678901234567890123456789'
           DC.B '--------------------------------------------------------------------------------'
           DC.B 'b2++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
           DC.B '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++b3'
  ALIGN
  BSS
REZ DS.W 1
DRIVE   DS.W 1
SECTORS DS.W 1
SIDE    DS.W 1
TRACK   DS.W 1
ERROR   DS.W 1
BUFFER  DS.W 10*512
  END
